// naumann@stce.rwth-aachen.de

#pragma once

#include "vector.hpp"

template<typename T>
class reverse_vector : public vector<T> {
  using vector<T>::v;
  using vector<T>::n;
public: 
  reverse_vector(size_t n) : vector<T>(n) {}
  reverse_vector<T>& operator=(const vector<T>& x) {
    if (&x==this) return *this;
    if (n==x.size()) {
      for (size_t i=0;i<n;i++) v[n-i-1]=x[i];
    }
    else {
      delete [] v; n=x.size(); v=new T[n]; 
      for (size_t i=0;i<n;i++) v[n-i-1]=x[i];
    }
    return *this;
  }
};
