// naumann@stce.rwth-aachen.de

#include "vector.hpp"

template<typename T>
class composition {
  vector<T> *v; // owned
public:
  composition() : v(new vector<T>) {}
  composition(vector<T> *v) : v(v) {}
  ~composition() { delete v; }
};

template<typename T>
class aggregation {
  vector<T> *v; // referenced
public:
  aggregation(vector<T> *v) : v(v) {}
  ~aggregation() {}
};
