#include<iostream>

template<typename T>
struct smart_ptr {
  T* p;
  smart_ptr(T* p) : p(p) {};
  ~smart_ptr() { 
    std::cout << "~" << std::endl;
    delete [] p; 
  }
};

void f(int i) {
  smart_ptr<int> p(new int(i)); 
  std::cout << *(p.p) << std::endl;
}

int main() {
  f(42);
  return 0;
}
