#include<iostream>

struct A {
  ~A() {
    std::cout << "~" << std::endl;
  }
};


template<typename T>
struct smart_ptr {
  T* p;
  smart_ptr(T* p) : p(p) {};
  ~smart_ptr() { 
    delete p; 
  }
};

template<typename T>
struct smart_array {
  T* p;
  smart_array(T* p) : p(p) {};
  ~smart_array() {
    delete [] p;
  }
};

void f(int n) {
  smart_array<A> p(new A[n]);
  smart_ptr<A> q(new A);
}

int main() {
  f(3);
  return 0;
}

